
QGIS Application - Bug report #4523

QGIS hangs when selecting a feature with the "Node Tool"

2011-11-13 02:40 AM - Giovanni Manghi

Status: Closed

Priority: High

Assignee:

Category: Digitising

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:Yes Copied to github as #: 14441

Description

Sample data here:

http://www.faunalia.pt/downloads/test_slow_vector.zip

Toggling editing and try use the node tool freezes QGIS.

This is the extreme case of the current poor performance when editing complex (with many nodes) lines/polygons.

Related issues:

Duplicated by QGIS Application - Bug report # 4433: Edit vertex tool very slow Closed 2011-10-24

Associated revisions

Revision e6167d24 - 2012-01-03 05:17 AM - Jürgen Fischer

fix #4523:

- make geometry validation optional: none, QGIS and GEOS

- move internal validation to QgsGeometryValidator thread

- cache wkt in QgsCoordinateReferenceSystem

- fTools: leave progress of geometry validatation at 100%

- move coordinate capture to vector menu

Revision 21f9dcd9 - 2012-01-04 03:03 PM - Jürgen Fischer

nodetool fixes (fixes #4523, #4737 & #4738)

Revision 9f4996fc - 2012-01-13 11:31 PM - Jürgen Fischer

more nodetool speedups & refactoring (fixes #4523)

[API] introduce signal QgsVectorLayer::geometryChanged() signal and use that

to reduce the need to reload the modified geometry.

History

#1 - 2011-11-14 01:51 AM - Marco Hugentobler

- Assignee deleted (Marco Hugentobler)
Most of the time is spent for validating the geometries. We discussed the possibility of having an option for turning those checks off.

#2 - 2011-11-14 09:54 AM - Martin Dobias

Actually we could remove the validation procedures from QGIS and use GEOSIsValidDetail from GEOS (available from version 3.3). The advantage is

that it would be (much) faster, the disadvantage is that only the first problem would be reported - probably not such a big deal?

Anyway also without the validation there are further speed problems - redrawing of the editing markers etc.

#3 - 2011-11-15 12:26 AM - Giovanni Manghi

Martin Dobias wrote:

Actually we could remove the validation procedures from QGIS and use GEOSIsValidDetail from GEOS (available from version 3.3). The advantage

is that it would be (much) faster, the disadvantage is that only the first problem would be reported - probably not such a big deal?

Anyway also without the validation there are further speed problems - redrawing of the editing markers etc.

Hi Martin and Marco,

Please do whatever it is possible to do about this issue. Recently we noticed that QGIS slowed a lot when editing, even with not that much complex

geometries, kind of a showstopper for who needs to vector editing. In general this was a issue also before the recent regression.

Thanks in advance

#4 - 2011-11-15 12:27 AM - Giovanni Manghi

- Priority changed from Normal to High

#5 - 2011-12-16 02:10 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#6 - 2012-01-02 04:24 AM - Giovanni Manghi

- Crashes QGIS or corrupts data set to No

- Affected QGIS version set to master

I would consider this a blocking issue for any future major release of QGIS.

#7 - 2012-01-02 08:18 PM - Jürgen Fischer

- % Done changed from 0 to 100

- Status changed from Open to Closed

Fixed in changeset commit:"e6167d2424cede3b2c06a19bc478f68ac02f4c44".

#8 - 2012-01-03 01:52 AM - Giovanni Manghi
Hi Jurgen,

thanks for looking into this issue!

I have just compiled and I have seen the new option "validate geometries". I have set it to "off" but the result it doesn't seem to change much, at least with

the provided sample vector. It is necessary to set something else?

Thanks in advance.

#9 - 2012-01-03 04:44 AM - Jürgen Fischer

Giovanni Manghi wrote:

I have just compiled and I have seen the new option "validate geometries". I have set it to "off" but the result it doesn't seem to change much, at

least with the provided sample vector. It is necessary to set something else?

As Martin mentioned validation was not the only issue.  And apparently using GEOSisValidDetail isn't much faster than our internal validation (at least not

for the same file above).  Drawing of the vertex markers is also expensive.

#10 - 2012-01-03 10:37 AM - Giovanni Manghi

- Status changed from Closed to Open

As Martin mentioned validation was not the only issue.  And apparently using GEOSisValidDetail isn't much faster than our internal validation (at

least not for the same file above).  Drawing of the vertex markers is also expensive.

Hi Jurgen,

when the ticket was filed there were problems with vectors not really that big/complex. Since then the overall situation got much better, but I'm not sure if is

as good as in the past (until qgis 1.4 and maybe also 1.5), nevertheless now editing it is again not an issue in most of the cases.

While visualisation performances are not an issue any more (I will close #1978), there are still problems editing, with the node tool, big/complex vectors like

http://www.iucnredlist.org/spatial-data/MAMMALS_TERRESTRIAL.zip

but I understand is kind of an uncommon case (it is 650MB of many complex, overlapped polygons).

More interesting seems to be the vector linked in this ticket, it is just 18MB and is made of a very few complex multipart polygons. This case is not that

uncommon especially for its size/complexity.

#11 - 2012-01-03 03:53 PM - Jürgen Fischer

- Status changed from Open to Feedback

commit:a753fb05 has some more improvements and should speed up things as only the visible vertex markers are generated and renderered.  Please test

and leave feedback.
#12 - 2012-01-04 04:14 AM - Giovanni Manghi

Jürgen Fischer wrote:

commit:a753fb05 has some more improvements and should speed up things as only the visible vertex markers are generated and renderered. 

Please test and leave feedback.

Hi Jurgen,

there was really an improvement, now QGIS does not freeze/hangs any more when using the node tool on the provided vector, but selecting/moving nodes

is still a very slow operation, many seconds just too select a specific node, many seconds when moving it, depending on how many nodes the geometry

has.

I made a quick test and I noticed that if the geometry being edited has 40k/50k nodes editing is already a bit slow but still completely usable. With 80k/100k

nodes the node tool it is already barely usable (at least not usable for a real life use).

Would be better to test this limits on a more powerful machine (I used a i3 processor with 2gb of RAM on 64bit Linux) as I guess we can assume that such

complex/big geometries are usually edited especially by power users, with powerful machines.

I don't know if are consequences of this commits, but now I see two issues:

*) I cannot select any more more than one node with the node tool and the ctrl key

*) Selecting a node with the node tool in a point layer causes QGIS to crash

I will file tickets for this issues.

#13 - 2012-01-04 06:03 AM - Jürgen Fischer

- Status changed from Feedback to Closed

Fixed in changeset commit:"21f9dcd909fe8cd09cd3dee4d6530af9bb5a522d".

#14 - 2012-01-05 03:59 AM - Pietro Rossin

Hello

I just made a test with the 18Mb shp file (forest), both with 1.7.3 and 1.9.9.

My pc is a not so old workstation biprocessor (2x opteron 252 - 2600Mhz) 4Gb ram, Nvidia quadro fx4000, windows xp 32bit.

Qgis completely freezes on editing nodes, even if zooming in a lot.

bie

pietro

#15 - 2012-01-05 04:08 AM - Paolo Cavallini

Please add revision number for 1.9.9

Thanks.

#16 - 2012-01-05 04:28 AM - Pietro Rossin
QGIS version

1.9.90-Alpha

QGIS code revision

commit:ffa2cfd

pietro

#17 - 2012-01-05 04:39 AM - Jürgen Fischer

Pietro Rossin wrote:

commit:ffa2cfd

That doesn't contain the changes.  Try a current build of master.

#18 - 2012-01-05 04:49 AM - Pietro Rossin

Just upgraded to commit:d04bc8f

Now it doesn't freeze, it's still slow but it works.

pietro

#19 - 2012-01-13 03:04 AM - Giovanni Manghi

- Target version changed from Version 1.7.4 to Version 1.8.0

- File arcmap_editing_slowvector.7z added

- Status changed from Closed to Open

- Crashes QGIS or corrupts data changed from No to Yes

In my Windows testing machine QGIS-master still freezes when selecting a specific node with the node tool. The same happens on other machines of

others users I'm asking to test. A user sent me a screencast (attached) that shows the editing of this vector in Arcmap, indeed a bit slow, but completely

functional.

#20 - 2012-01-13 02:51 PM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"9f4996fc210eaa8c2495c912bc7214d37256ea63".

#21 - 2012-01-14 06:34 AM - Giovanni Manghi

Thanks Jurgen, it works like a charm now.

Files

arcmap_editing_slowvector.7z 3.28 MB 2012-01-13 Giovanni Manghi
